<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Domain Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id249241"></a>Domain Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Juha</span> <span class="surname">Heinanen</span></h3><code class="email">&lt;<a class="email" href="mailto:jh@tutpro.com">jh@tutpro.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Juha</span> <span class="surname">Heinanen</span></h3><code class="email">&lt;<a class="email" href="mailto:jh@tutpro.com">jh@tutpro.com</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2002-2008 Juha Heinanen</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2009-07-21 09:45:05 +0200 (Tue, 21 Jul 2009) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id279025">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id270210">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id267838">1.2. Dependencies</a></span></dt><dt><span class="section"><a href="#id248009">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248015">1.3.1. <code class="varname">db_url</code> (string)</a></span></dt><dt><span class="section"><a href="#id248346">1.3.2. <code class="varname">db_mode</code> (integer)</a></span></dt><dt><span class="section"><a href="#id248374">1.3.3. <code class="varname">domain_table</code> (string)</a></span></dt><dt><span class="section"><a href="#id248408">1.3.4. <code class="varname">domain_col</code> (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id248441">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id248446">1.4.1. <code class="function">is_from_local()</code></a></span></dt><dt><span class="section"><a href="#id293402">1.4.2. <code class="function">is_uri_host_local()</code></a></span></dt><dt><span class="section"><a href="#id293433">1.4.3. <code class="function">is_domain_local(pseudo_variable)</code></a></span></dt></dl></dd><dt><span class="section"><a href="#id293481">1.5. Exported MI Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293486">1.5.1. <code class="function">domain_reload</code></a></span></dt><dt><span class="section"><a href="#id293519">1.5.2. <code class="function">domain_dump</code></a></span></dt></dl></dd><dt><span class="section"><a href="#id293554">1.6. Known Limitations</a></span></dt></dl></dd><dt><span class="chapter"><a href="#id294036">2. Developer Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id293732">2.1. Available Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293724">2.1.1. 
		<code class="function">is_domain_local(domain)</code>
		</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248333">Setting db_url parameter</a></dt><dt>1.2. <a href="#id248361">db_mode example</a></dt><dt>1.3. <a href="#id248395">Setting domain_table parameter</a></dt><dt>1.4. <a href="#id248426">Setting domain_col parameter</a></dt><dt>1.5. <a href="#id248463">is_from_local usage</a></dt><dt>1.6. <a href="#id293420">is_uri_host_local usage</a></dt><dt>1.7. <a href="#id293465">is_domain_local usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id279025"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id270210"></a>1.1. Overview</h2></div></div></div><p>
		Domain module implements checks that based on domain table determine 
		if a host part of an <acronym class="acronym">URI</acronym> is &#8220;<span class="quote">local</span>&#8221; or 
		not.  A &#8220;<span class="quote">local</span>&#8221; domain is one that the proxy is responsible 
		for.
	</p><p>
		Domain module operates in caching or non-caching mode depending on 
		value of module parameter <em class="parameter"><code>db_mode</code></em>.
		In caching mode domain module reads the contents of domain table into 
		cache memory when the module is loaded.  After that domain table is 
		re-read only when module is given domain_reload fifo command.  Any
		changes in domain table must thus be followed by 
		&#8220;<span class="quote">domain_reload</span>&#8221; command in order to reflect them in 
		module behavior. In non-caching mode domain module always queries domain
		table in the database.
	</p><p>
		Caching is implemented using a hash table. The size of the hash table 
		is given by HASH_SIZE constant defined in domain_mod.h. 
		Its &#8220;<span class="quote">factory default</span>&#8221; value is 128.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id267838"></a>1.2. Dependencies</h2></div></div></div><p>
		The module depends on the following modules (in the other words the 
		listed modules must be loaded before this module):
		</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>database</em></span> -- Any database module</p></li></ul></div><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248009"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248015"></a>1.3.1. <code class="varname">db_url</code> (string)</h3></div></div></div><p>
		This is <acronym class="acronym">URL</acronym> of the database to be used.
		</p><p>
		Default value is 
			&#8220;<span class="quote">mysql://opensipsro:opensipsro@localhost/opensips</span>&#8221;
		</p><div class="example"><a name="id248333"></a><p class="title"><b>Example 1.1. Setting db_url parameter</b></p><div class="example-contents"><pre class="programlisting">
modparam("domain", "db_url", "mysql://ser:pass@db_host/ser")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248346"></a>1.3.2. <code class="varname">db_mode</code> (integer)</h3></div></div></div><p>
		Database mode: 0 means non-caching, 1 means caching.
		</p><p>
		Default value is 0 (non-caching).
		</p><div class="example"><a name="id248361"></a><p class="title"><b>Example 1.2. db_mode example</b></p><div class="example-contents"><pre class="programlisting">
modparam("domain", "db_mode", 1)   # Use caching
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248374"></a>1.3.3. <code class="varname">domain_table</code> (string)</h3></div></div></div><p>
		Name of table containing names of local domains that the proxy is 
		responsible for. Local users must have in their sip uri a host part 
		that is equal to one of these domains.
		</p><p>
		Default value is &#8220;<span class="quote">domain</span>&#8221;.
		</p><div class="example"><a name="id248395"></a><p class="title"><b>Example 1.3. Setting domain_table parameter</b></p><div class="example-contents"><pre class="programlisting">
modparam("domain", "domain_table", "new_name")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248408"></a>1.3.4. <code class="varname">domain_col</code> (string)</h3></div></div></div><p>
		Name of column containing domains in domain table.
		</p><p>
		Default value is &#8220;<span class="quote">domain</span>&#8221;.
		</p><div class="example"><a name="id248426"></a><p class="title"><b>Example 1.4. Setting domain_col parameter</b></p><div class="example-contents"><pre class="programlisting">
modparam("domain", "domain_col", "domain_name")
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248441"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248446"></a>1.4.1. <code class="function">is_from_local()</code></h3></div></div></div><p>
		Checks based on domain table if host part of From header uri is
		one of the local domains that the proxy is responsible for
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id248463"></a><p class="title"><b>Example 1.5. is_from_local usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (is_from_local()) {
	...
};
...
		</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293402"></a>1.4.2. <code class="function">is_uri_host_local()</code></h3></div></div></div><p>
		If called from route or failure route block, checks
		based on domain table if host part of Request-URI is one
		of the local domains that the proxy is responsible for.
		If called from branch route, the test is made on host
		part of URI of first branch, which thus must have been
		appended to the transaction before is_uri_host_local()
		is called.
		</p><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE,
		BRANCH_ROUTE.
		</p><div class="example"><a name="id293420"></a><p class="title"><b>Example 1.6. is_uri_host_local usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (is_uri_host_local()) {
	...
};
...
		</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293433"></a>1.4.3. <code class="function">is_domain_local(pseudo_variable)</code></h3></div></div></div><p>
		This function checks if the domain contained in the
		pseudo_variable is local.
		</p><p>
		This function is a generalized form of the is_from_local()
		and is_uri_host_local() functions, being able to completely
		replace them and also extends them by allowing the domain to
		be taken from any of the above mentioned sources.
                The following equivalences exist:
		</p><div class="itemizedlist"><ul type="disc"><li><p>
			is_domain_local("$rd") is same as is_uri_host_local()
		</p></li><li><p>
			is_domain_local("$fd") is same as is_from_local()
		</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE, FAILURE_ROUTE,
		BRANCH_ROUTE.
		</p><div class="example"><a name="id293465"></a><p class="title"><b>Example 1.7. is_domain_local usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (is_domain_local("$rd")) {
	...
};
if (is_domain_local("$fd")) {
	...
};
if (is_domain_local("$avp(some_avp_alias)")) {
	...
};
if (is_domain_local("$avp(850)")) {
	...
};
if (is_domain_local("$avp(some_avp)")) {
	...
};
...
		</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293481"></a>1.5. Exported MI Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293486"></a>1.5.1. <code class="function">domain_reload</code></h3></div></div></div><p>
		Causes domain module to re-read the contents of domain table
		into cache memory.
		</p><p>
		Name: <span class="emphasis"><em>domain_reload</em></span>
		</p><p>Parameters: <span class="emphasis"><em>none</em></span></p><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
		:domain_reload:_reply_fifo_file_
		_empty_line_
		</pre></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293519"></a>1.5.2. <code class="function">domain_dump</code></h3></div></div></div><p>
		Causes domain module to dump hash indexes and domain names in
		its cache memory.
		</p><p>
		Name: <span class="emphasis"><em>domain_dump</em></span>
		</p><p>Parameters: <span class="emphasis"><em>none</em></span></p><p>
		MI FIFO Command Format:
		</p><pre class="programlisting">
		:domain_dump:_reply_fifo_file_
		_empty_line_
		</pre></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293554"></a>1.6. Known Limitations</h2></div></div></div><p>
		There is an unlikely race condition on domain list update.  If a 
		process uses a table, which is reloaded at the same time twice 
		through <acronym class="acronym">FIFO</acronym>, the second reload will delete the 
		original table still in use by the process.
	</p></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id294036"></a>Chapter 2. Developer Guide</h2></div></div></div><p>
	The module provides is_domain_local <acronym class="acronym">API</acronym>
    function for use by other OpenSIPS modules.
    </p><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293732"></a>2.1. Available Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293724"></a>2.1.1. 
		<code class="function">is_domain_local(domain)</code>
		</h3></div></div></div><p>
		Checks if domain given in str* parameter is local.
		</p><p>
		The function returns 1 if domain is local and -1 if
		domain is not local or if an error occurred.
		</p></div></div></div></div></body></html>
